"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GenomicEntity(ProtocolElement):
    """
    A genomic feature
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "otherIds": reports_6_9_0.Identifier,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "type": reports_6_9_0.GenomicEntityType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.Identifier": reports_6_9_0.Identifier,
            "org.gel.models.report.avro.GenomicEntityType": reports_6_9_0.GenomicEntityType,
            "org.gel.models.report.avro.GenomicEntity": reports_6_9_0.GenomicEntity,
        }

    __slots__ = [
        "type",
        "ensemblId",
        "geneSymbol",
        "otherIds",
    ]

    def __init__(
        self,
        type,
        ensemblId=None,
        geneSymbol=None,
        otherIds=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.GenomicEntity model.

        :param type:
            The type of the genomic entity
        :type type: GenomicEntityType
        :param ensemblId:
            Ensembl identifier for the feature (e.g, ENST00000544455)
        :type ensemblId: None | str
        :param geneSymbol:
            The HGNC gene symbol. This field is optional, BUT it should be filled
            if possible
        :type geneSymbol: None | str
        :param otherIds:
            Others identifiers for this genomic feature
        :type otherIds: None | list[Identifier]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
